Index: branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.basicformats/.directory
===================================================================
--- branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.basicformats/.directory	(revision 0)
+++ branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.basicformats/.directory	(revision 43876)
@@ -0,0 +1,4 @@
+[Dolphin]
+Timestamp=2018,6,29,17,39,39
+Version=3
+ViewMode=1
Index: branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.basicformats/src/main/java/org/gvsig/basicformats/impl/DefaultCLRFile.java
===================================================================
--- branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.basicformats/src/main/java/org/gvsig/basicformats/impl/DefaultCLRFile.java	(revision 0)
+++ branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.basicformats/src/main/java/org/gvsig/basicformats/impl/DefaultCLRFile.java	(revision 43876)
@@ -0,0 +1,111 @@
+package org.gvsig.basicformats.impl;
+
+import java.awt.Color;
+import java.io.File;
+import java.io.IOException;
+import java.util.ArrayList;
+import java.util.List;
+import org.apache.commons.io.FileUtils;
+import org.apache.commons.io.FilenameUtils;
+import org.apache.commons.lang3.StringUtils;
+import org.gvsig.basicformats.CLRFile;
+import org.gvsig.raster.lib.legend.api.RasterLegendLocator;
+import org.gvsig.raster.lib.legend.api.RasterLegendManager;
+import org.gvsig.raster.lib.legend.api.colortable.ColorTable;
+import org.gvsig.raster.lib.legend.api.colortable.colortableclass.ColorTableClass;
+import org.slf4j.Logger;
+import org.slf4j.LoggerFactory;
+
+public class DefaultCLRFile implements CLRFile {
+
+    private static final Logger logger = LoggerFactory.getLogger(DefaultCLRFile.class);
+
+    private File source;
+    private ColorTable colorTable;
+
+    public DefaultCLRFile() {
+        this.source = null;
+        this.colorTable = null;
+    }
+
+    @Override
+    public File getFile(File file) {
+        File f = new File(FilenameUtils.removeExtension(file.getAbsolutePath()) + "." + FILE_EXTENSION);
+        return f;
+    }
+
+    @Override
+    public File getFile() {
+        return source;
+    }
+
+    @Override
+    public ColorTable getColorTable() {
+        return this.colorTable;
+    }
+
+    @Override
+    public void setColorTable(ColorTable colorTable) {
+        this.colorTable = colorTable;
+    }
+
+    @Override
+    public void read(File file) throws IOException {
+        File f = this.getFile(file);
+        if (f.exists()) {
+            try {
+                RasterLegendManager legendManager = RasterLegendLocator.getRasterLegendManager();
+                List<ColorTableClass> colors = new ArrayList<>();
+                List<String> lines = FileUtils.readLines(f);
+                if (lines != null) {
+                    this.source = f.getAbsoluteFile();
+                    int lineno = 1;
+                    double interpolation = 50.0;
+                    for (String line : lines) {
+                        line = line.trim();
+                        if (!Character.isDigit(line.charAt(0))) {
+                            continue;
+                        }
+                        try {
+                            String[] words = StringUtils.split(line);
+                            if (words.length < 4) {
+                                continue;
+                            }
+                            int value = Integer.parseInt(words[0]);
+                            int r = Integer.parseInt(words[1]);
+                            int g = Integer.parseInt(words[2]);
+                            int b = Integer.parseInt(words[3]);
+                            Color color = new Color(r, g, b);
+
+                            ColorTableClass colorTableClass = legendManager.createColorTableClass(
+                                    String.valueOf(value), value, interpolation, color);
+
+                            colors.add(colorTableClass);
+                        } catch (Exception e) {
+                            logger.warn("Can't parse line '" + line
+                                    + "' (lineno=+" + lineno
+                                    + ", file=" + f.getAbsoluteFile()
+                                    + ").", e);
+
+                        }
+                    }
+                }
+                if( !colors.isEmpty() ) {
+                    String colorTableName = FilenameUtils.getBaseName(f.getName());
+                    this.colorTable = legendManager.createColorTable(colorTableName, colors, true);
+                }
+            } catch (IOException e) {
+                logger.warn("Couldn't read " + FILE_EXTENSION + " file (" + f.getAbsoluteFile() + ")", e);
+                throw e;
+            }
+        }
+
+    }
+
+    @Override
+    public void write(File file) throws IOException {
+        File f = this.getFile(file);
+        // TODO: falta implementar guardar la CLR
+    }
+
+}
Index: branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.basicformats/src/main/java/org/gvsig/basicformats/impl/DefaultWLDFile.java
===================================================================
--- branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.basicformats/src/main/java/org/gvsig/basicformats/impl/DefaultWLDFile.java	(revision 0)
+++ branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.basicformats/src/main/java/org/gvsig/basicformats/impl/DefaultWLDFile.java	(revision 43876)
@@ -0,0 +1,186 @@
+package org.gvsig.basicformats.impl;
+
+import java.io.File;
+import java.io.IOException;
+import java.util.List;
+import org.apache.commons.io.FileUtils;
+import org.apache.commons.io.FilenameUtils;
+import org.gvsig.basicformats.WLDFile;
+import org.gvsig.fmap.geom.Geometry;
+import org.gvsig.fmap.geom.GeometryLocator;
+import org.gvsig.fmap.geom.primitive.Envelope;
+import org.slf4j.Logger;
+import org.slf4j.LoggerFactory;
+
+
+public class DefaultWLDFile implements WLDFile {
+    
+    private static final Logger logger = LoggerFactory.getLogger(DefaultWLDFile.class);
+    
+        
+    private File source;
+    
+    private double pixelSizeX;
+    private double rotationAxisY;
+    private double rotationAxisX;
+    private double pixelSizeY;
+    private double upperLeftPixelCenterCoordX;
+    private double upperLeftPixelCenterCoordY;
+
+    public DefaultWLDFile() {
+        this.source = null;
+    }
+    
+    @Override
+    public File getFile(File file) {
+        File f = new File(FilenameUtils.removeExtension(file.getAbsolutePath())+"."+FILE_EXTENSION);
+        return f;
+    }
+    
+    @Override
+    public File getFile() {
+        return source;
+    }
+
+    @Override
+    public void read(File file) throws IOException {
+        File f = this.getFile(file);
+        if (f.exists()) {
+            try {
+                List<String> lines = FileUtils.readLines(f);
+                if (lines!=null ) {
+                    this.source = f.getAbsoluteFile();
+                    int lineno = 0;
+                    for (String line : lines) {
+                        line = line.trim();
+                        char ch = line.charAt(0);
+                        if( lineno>5 || Character.isLetter(ch) || ch==';' || ch=='#' ) {
+                            continue;
+                        }
+                        try {
+                            double value = Double.parseDouble(line);
+                            switch(lineno) {
+                                case 0:
+                                    this.pixelSizeX=value;
+                                    break;
+                                case 1:
+                                    this.rotationAxisY = value;
+                                    break;
+                                case 2:
+                                    this.rotationAxisX = value;
+                                    break;
+                                case 3:
+                                    this.pixelSizeY = value;
+                                    break;
+                                case 4:
+                                    this.upperLeftPixelCenterCoordX = value;
+                                    break;
+                                case 5:
+                                    this.upperLeftPixelCenterCoordY = value;
+                                    break;
+                            }
+                            lineno++;
+                        } catch(NumberFormatException e) {
+                            
+                        }
+                    }
+                }
+
+            } catch (IOException e) {
+                logger.warn("Couldn't read "+FILE_EXTENSION+" file ("+f.getAbsolutePath()+").",e);
+                throw e;
+            }
+        }
+    }
+
+    @Override
+    public Envelope getEnvelope(int rows, int columns) {
+        Envelope envelope = null;
+        if (0.0 != getRotationAxisX() || 0.0 != getRotationAxisY()) {
+            logger.warn("Rotation in wld file not implemented yet. It will be ignored");
+        }
+
+        double leftMostX = 0;
+        double upperMostY = 0;
+        double height = 0;
+        double width = 0;
+        try {
+            leftMostX = getUpperLeftPixelCenterCoordX() - (getPixelSizeX() * 0.5);
+            upperMostY = getUpperLeftPixelCenterCoordY() - (getPixelSizeY() * 0.5);
+            height=rows*getPixelSizeY();
+            width=columns*getPixelSizeX();
+
+            envelope = GeometryLocator.getGeometryManager().createEnvelope(
+                Math.min(leftMostX,leftMostX + width),
+                Math.min(upperMostY,upperMostY + height),
+                Math.max(leftMostX,leftMostX + width),
+                Math.max(upperMostY,upperMostY + height),
+                Geometry.SUBTYPES.GEOM2D);
+        } catch (Exception e) {
+            logger.warn(
+                "Failed to create envelope from wld file with coords: minx:"+leftMostX+
+                ", miny:"+upperMostY+", maxX: "+leftMostX + width+", maxY: "+upperMostY + height, e);
+        }
+        return envelope;        
+    }
+    
+    @Override
+    public void write(File file) {
+        // TODO: Falta implementar el write del WLDFile
+        File f = this.getFile(file);
+
+    }
+    
+    @Override
+    public void setValue(Envelope envelope, int rows, int columns) {
+        // TODO: Falta implementar el setValue del WLDFile
+    }
+
+    /**
+     * @return the pixelSizeX
+     */
+    @Override
+    public double getPixelSizeX() {
+        return pixelSizeX;
+    }
+
+    /**
+     * @return the rotationAxisY
+     */
+    @Override
+    public double getRotationAxisY() {
+        return rotationAxisY;
+    }
+
+    /**
+     * @return the rotationAxisX
+     */
+    @Override
+    public double getRotationAxisX() {
+        return rotationAxisX;
+    }
+
+    /**
+     * @return the pixelSizeY
+     */
+    @Override
+    public double getPixelSizeY() {
+        return pixelSizeY;
+    }
+
+    /**
+     * @return the upperLeftPixelCenterCoordX
+     */
+    @Override
+    public double getUpperLeftPixelCenterCoordX() {
+        return upperLeftPixelCenterCoordX;
+    }
+
+    /**
+     * @return the upperLeftPixelCenterCoordY
+     */
+    @Override
+    public double getUpperLeftPixelCenterCoordY() {
+        return upperLeftPixelCenterCoordY;
+    }
+}
Index: branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.basicformats/src/main/java/org/gvsig/basicformats/impl/DefaultCPGFile.java
===================================================================
--- branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.basicformats/src/main/java/org/gvsig/basicformats/impl/DefaultCPGFile.java	(revision 0)
+++ branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.basicformats/src/main/java/org/gvsig/basicformats/impl/DefaultCPGFile.java	(revision 43876)
@@ -0,0 +1,225 @@
+package org.gvsig.basicformats.impl;
+
+import java.io.File;
+import java.io.IOException;
+import org.apache.commons.io.FileUtils;
+import org.apache.commons.io.FilenameUtils;
+import org.apache.commons.lang3.StringUtils;
+import org.gvsig.basicformats.CPGFile;
+import org.slf4j.Logger;
+import org.slf4j.LoggerFactory;
+
+
+public class DefaultCPGFile implements CPGFile {
+
+    private static final Logger logger = LoggerFactory.getLogger(DefaultPRJFile.class);
+
+
+    private File source;
+    private String charsetName = null;
+
+    /**
+     * Define the valid code pages (equivalent to MSDOS code pages). 
+     * This codes are used on the byte 29 of the DBF header to define the DBF
+     * codepage.
+     *
+     * The equivalences of these charsets using Java NIO charset names are
+     * defined on the {@link #charsetNames} array (so 0x01 is
+     * equivalent to IBM437, 0x02 to IBM850, etc)
+     *
+     * See some other equivalences in:
+     * https://github.com/infused/dbf/blob/master/docs/supported_encodings.csv
+     * https://github.com/olemb/dbfread/blob/master/dbfread/codepages.py
+     * https://joinup.ec.europa.eu/svn/gvsig-desktop/trunk/libraries/libFMap/src/com/iver/cit/gvsig/fmap/drivers/dbf/DbfEncodings.java
+     */
+    private static final short[] codePages = {
+        0x01, 0x02, 0x03, 0x04,
+        0x08, 0x09, 0x0a, 0x0b,
+        0x0d, 0x0e, 0x0f, 0x10,
+        0x11, 0x12, 0x13, 0x14,
+        0x15, 0x16, 0x17, 0x18,
+        0x19, 0x1a, 0x1b, 0x1c,
+        0x1d, 0x1f, 0x22, 0x23,
+        0x24, 0x25, 0x26, 0x37,
+        0x40, 0x4d, 0x4e, 0x4f,
+        0x50, 0x57, 0x58, 0x59,
+        0x64, 0x65, 0x66, 0x67,
+        0x68, 0x69, 0x6a, 0x6b,
+        0x6c, 0x78, 0x79, 0x7a,
+        0x7b, 0x7c, 0x7d, 0x7d,
+        0x86, 0x87, 0x88, 0xc8,
+        0xc9, 0xca, 0xcb, 0xcc};
+
+    /**
+     * Equivalent Java charset names to the code pages defined in
+     * {@link #codePages}, using Java NIO Charset names (which differ
+     * from JAVA IO names, see
+     * https://docs.oracle.com/javase/8/docs/technotes/guides/intl/encoding.doc.html)
+     */
+    private static final String[] charsetNames = new String[]{
+        "IBM437", "IBM850", "windows-1252", "x-MacRoman",
+        "IBM865", "IBM437", "IBM850", "IBM437",
+        "IBM437", "IBM850", "IBM437", "IBM850",
+        "IBM437", "IBM850", "x-IBM943", "IBM850",
+        "IBM437", "IBM850", "IBM865", "IBM437",
+        "IBM437", "IBM850", "IBM437", "IBM863",
+        "IBM850", "IBM852", "IBM852", "IBM852",
+        "IBM860", "IBM850", "IBM866", "IBM850",
+        "IBM852", "x-mswin-936", "x-IBM949", "IBM950",
+        "x-IBM874", "windows-1252", "windows-1252", "windows-1252",
+        "IBM852", "IBM866", "IBM865", "IBM861",
+        // 0x68 and 0x69 are unofficial "Codepage 895 Kamenicky (Czech) MS-DOS" and "Codepage 620  Mazovia (Polish) MS-DOS",
+        // but there is no Java equivalent
+        // so we use CP437 which is the closest charset for the latin characters part
+        "IBM437", "IBM437", "x-IBM737", "IBM857",
+        "IBM863", "x-IBM950", "x-IBM949", "x-mswin-936",
+        "x-IBM942", "x-IBM874", "windows-1255", "windows-1256",
+        "x-IBM737", "IBM852", "IBM857", "windows-1250",
+        "windows-1251", "windows-1254", "windows-1253", "windows-1257"};
+
+    public DefaultCPGFile() {
+        this.charsetName = null;
+        this.source = null;
+    }
+
+    @Override
+    public File getFile(File file) {
+        File f = new File(FilenameUtils.removeExtension(file.getAbsolutePath()) + "." + FILE_EXTENSION);
+        return f;
+    }
+
+    @Override
+    public File getFile() {
+        return source;
+    }
+
+    @Override
+    public String getCharsetName() {
+        return this.charsetName;
+    }
+
+    @Override
+    public void setCharsetName(String charsetName) {
+        this.charsetName = charsetName;
+    }
+
+    @Override
+    public String toCharsetName(String codePageName) {
+        if (codePageName.equals("UTF8")) {
+            return "UTF-8";
+        }
+        if (codePageName.equals("SJIS")) {
+            return "Shift_JIS";
+        }
+
+        if (StringUtils.isNumeric(codePageName)) {
+            if (codePageName.startsWith("8859") && codePageName.length() > 4) {
+                return "ISO-8859-" + codePageName.substring(4);
+            }
+            if (codePageName.startsWith("125") && codePageName.length() == 4) {
+                return "windows-" + codePageName;
+            }
+            if (codePageName.length() == 3) {
+                return "IBM-" + codePageName;
+            }
+            for (int i = 0; i < charsetNames.length; i++) {
+                if (charsetNames[i].contains(codePageName)) {
+                    return codePageName;
+                }
+            }
+        }
+        if (codePageName.equals("65001")) {
+            return "UTF-8";
+        }
+        return codePageName;
+    }
+
+    /**
+     * Gets the Java NIO charset name equivalent to the provided code page.
+     * Gets null if the provided code page is not recognised
+     * as a valid code
+     *
+     * @param codePage
+     * @return
+     */
+    @Override
+    public String toCharsetName(int codePage) {
+        if (codePage != 0) {
+            for (int i = 0; i < codePages.length; i++) {
+                if (codePages[i] == codePage) {
+                    return charsetNames[i];
+                }
+            }
+        }
+        return null;
+    }
+
+    @Override
+    public String toCPGName(String charsetName) {
+        if (charsetName.startsWith("windows-")
+                || charsetName.startsWith("ISO-8859")
+                || charsetName.startsWith("IBM-")
+                || charsetName.startsWith("x-IBM")
+                || charsetName.startsWith("x-mswin-")) {
+            return charsetName.replaceAll("[^\\d]", "");
+        }
+        if (charsetName.equals("Shift_JIS")) {
+            return "SJIS";
+        }
+        // For the rest of the charsets, we'll directly write the Java NIO Charset
+        // Probably they will only be recognized by gvSIG, but it's better than nothing
+        return charsetName;
+    }
+
+    /**
+     * Returns the code page corresponding to the
+     * provided charset name
+     *
+     * @param charsetName
+     * @return The code page, or 0x00 if no equivalent code page was found for
+     * the provided charsetName
+     */
+    @Override
+    public int toCPG(String charsetName) {
+        for (int i = 0; i < charsetNames.length; i++) {
+            if (charsetNames[i].equals(charsetName)) {
+                return codePages[i];
+            }
+        }
+        // default
+        return 0x00;
+    }
+
+    @Override
+    public void read(File file) throws IOException {
+        File f = this.getFile(file);
+        if (f.exists()) {
+            try {
+                String theContents = FileUtils.readFileToString(f);
+                theContents = StringUtils.trim(theContents);
+                if (StringUtils.isNotEmpty(theContents)) {
+                    String theCharset = toCharsetName(theContents);
+                    this.charsetName = theCharset;
+                    this.source = f.getAbsoluteFile();
+                }
+            } catch (IOException e) {
+                logger.warn("Couldn't read " + FILE_EXTENSION + " file (" + f.getAbsolutePath() + ").", e);
+                throw e;
+            }
+        }
+    }
+
+    @Override
+    public void write(File file) throws IOException {
+        File f = this.getFile(file);
+        try {
+            String export = toCPGName(this.charsetName) + "\n";
+            FileUtils.writeStringToFile(f, export, "ISO-8859-1");
+            this.source = f;
+        } catch (Exception e) {
+            logger.warn("Couldn't write " + FILE_EXTENSION + " file (" + f.getAbsolutePath() + ").", e);
+            throw e;
+        }
+    }
+
+}
Index: branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.basicformats/src/main/java/org/gvsig/basicformats/impl/DefaultPRJFile.java
===================================================================
--- branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.basicformats/src/main/java/org/gvsig/basicformats/impl/DefaultPRJFile.java	(revision 0)
+++ branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.basicformats/src/main/java/org/gvsig/basicformats/impl/DefaultPRJFile.java	(revision 43876)
@@ -0,0 +1,85 @@
+
+package org.gvsig.basicformats.impl;
+
+
+import java.io.File;
+import java.io.IOException;
+import org.apache.commons.io.FileUtils;
+import org.apache.commons.io.FilenameUtils;
+import org.apache.commons.lang3.StringUtils;
+import org.cresques.cts.ICRSFactory;
+import org.cresques.cts.IProjection;
+import org.gvsig.basicformats.PRJFile;
+import org.gvsig.fmap.crs.CRSFactory;
+import org.slf4j.Logger;
+import org.slf4j.LoggerFactory;
+
+
+public class DefaultPRJFile implements PRJFile {
+            
+    private static final Logger logger = LoggerFactory.getLogger(DefaultPRJFile.class);
+    
+        
+    private File source;
+    private IProjection crs;
+    
+    public DefaultPRJFile() {
+        this.source = null;
+        this.crs = null;        
+    }
+
+    @Override
+    public File getFile(File file) {
+        File f = new File(FilenameUtils.removeExtension(file.getAbsolutePath())+"."+FILE_EXTENSION);
+        return f;
+    }
+    
+    @Override
+    public File getFile() {
+        return source;
+    }
+    
+    @Override
+    public IProjection getCRS() {
+        return this.crs;
+    }
+    
+    @Override
+    public void setCRS(IProjection crs) {
+        this.crs = crs;
+    }
+    
+    @Override
+    public void read(File file) throws IOException {
+        File f = this.getFile(file);
+        if (f.exists()) {
+            try {
+                String theContents = FileUtils.readFileToString(f);
+                if (StringUtils.isNotEmpty(theContents)){
+                    IProjection theCrs=CRSFactory.getCRSFactory().get(ICRSFactory.FORMAT_WKT_ESRI, theContents);
+                    this.crs = theCrs;
+                    this.source = f.getAbsoluteFile();
+                }
+            } catch (IOException e) {
+                logger.warn("Couldn't read "+FILE_EXTENSION+" file ("+f.getAbsolutePath()+").",e);
+                throw e;
+            }
+        }
+            
+    }
+    
+    @Override
+    public void write(File file) throws IOException {
+        File f = this.getFile(file);
+        try {
+            String export = crs.export(ICRSFactory.FORMAT_WKT_ESRI);
+            if(export!=null){
+                FileUtils.writeStringToFile(f, export);
+                this.source = f;
+            }
+        } catch (Exception e) {
+            logger.warn("Couldn't write "+FILE_EXTENSION+" file ("+f.getAbsolutePath()+").",e);
+            throw e;
+        }
+    }
+}
